Xerces2 Implementation: Class DefaultText

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xerces.impl.xs.opti
Class DefaultText

    java.lang.Object
      |
      +--org.apache.xerces.impl.xs.opti.DefaultNode
            |
            +--org.apache.xerces.impl.xs.opti.NodeImpl
                  |
                  +--org.apache.xerces.impl.xs.opti.DefaultText

All Implemented Interfaces:
  org.w3c.dom.CharacterData, org.w3c.dom.Node, org.w3c.dom.Text

Direct Known Subclasses:
  TextImpl

public class DefaultText
extends NodeImpl
implements org.w3c.dom.Text

The `Text` interface inherits from `CharacterData` and represents the textual content (termed character data in XML) of an `Element` or `Attr`. If there is no markup inside an element's content, the text is contained in a single object implementing the `Text` interface that is the only child of the element. If there is markup, it is parsed into the information items (elements, comments, etc.) and `Text` nodes that form the list of children of the element.

When a document is first made available via the DOM, there is only one `Text` node for each block of text. Users may create adjacent `Text` nodes that represent the contents of a given element without any intervening markup, but should be aware that there is no way to represent the separations between these nodes in XML or HTML, so they will not (in general) persist between DOM editing sessions. The `normalize()` method on `Node` merges any such adjacent `Text` objects into a single node for each block of text.

See also the Document Object Model (DOM) Level 2 Core Specification. This is an empty implementation.

# INTERNAL:

  Usage of this class is not supported. It may be altered or removed at any time.

Version:
  $Id: DefaultText.java 446728 2006-09-15 20:43:46Z mrglavas $
Author:
  Neil Graham, IBM

Fields inherited from interface org.w3c.dom.Node
`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Constructor Summary
`DefaultText()`

Method Summary
`void` | `appendData(java.lang.String arg)` Append the string to the end of the character data of the node.
`void` | `deleteData(int offset, int count)` Remove a range of 16-bit units from the node.
`java.lang.String` | `getData()` The character data of the node that implements this interface.
`int` | `getLength()` The number of 16-bit units that are available through `data` and the `substringData` method below.
`java.lang.String` | `getWholeText()` Returns all text of `Text` nodes logically-adjacent text nodes to this node, concatenated in document order.
`void` | `insertData(int offset, java.lang.String arg)` Insert a string at the specified 16-bit unit offset.
`boolean` | `isElementContentWhitespace()` DOM Level 3 CR
`void` | `replaceData(int offset, int count, java.lang.String arg)` Replace the characters starting at the specified 16-bit unit offset with the specified string.
`org.w3c.dom.Text` | `replaceWholeText(java.lang.String content)` Replaces the text of the current node and all logically-adjacent text nodes with the specified text.
`void` | `setData(java.lang.String data)` The character data of the node that implements this interface.
`org.w3c.dom.Text` | `splitText(int offset)` Breaks this node into two nodes at the specified `offset`, keeping both in the tree as siblings.
`java.lang.String` | `substringData(int offset, int count)` Extracts a range of data from the node.

Methods inherited from class org.apache.xerces.impl.xs.opti.NodeImpl
`getLocalName, getNamespaceURI, getNodeName, getNodeType, getPrefix, getReadOnly, setReadOnly`

Methods inherited from class org.apache.xerces.impl.xs.opti.DefaultNode
`appendChild, cloneNode, compareDocumentPosition, getAttributes, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getNextSibling, getNodeValue, getOwnerDocument, getParentNode, getPreviousSibling, getTextContent, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.w3c.dom.Node
`appendChild, cloneNode, compareDocumentPosition, getAttributes, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeName, getNodeType, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

Constructor Detail

### DefaultText

    public DefaultText()

Method Detail

### getData

    public java.lang.String getData()
                             throws org.w3c.dom.DOMException

  The character data of the node that implements this interface. The DOM implementation may not put arbitrary limits on the amount of data that may be stored in a `CharacterData` node. However, implementation limits may mean that the entirety of a node's data may not fit into a single `DOMString`. In such cases, the user may call `substringData` to retrieve the data in appropriately sized pieces.
  Specified by:
    `getData` in interface `org.w3c.dom.CharacterData`
  Throws:
    `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
    `org.w3c.dom.DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

### setData

    public void setData(java.lang.String data)
                 throws org.w3c.dom.DOMException

  The character data of the node that implements this interface. The DOM implementation may not put arbitrary limits on the amount of data that may be stored in a `CharacterData` node. However, implementation limits may mean that the entirety of a node's data may not fit into a single `DOMString`. In such cases, the user may call `substringData` to retrieve the data in appropriately sized pieces.
  Specified by:
    `setData` in interface `org.w3c.dom.CharacterData`
  Throws:
    `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
    `org.w3c.dom.DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

### getLength

    public int getLength()

  The number of 16-bit units that are available through `data` and the `substringData` method below. This may have the value zero, i.e., `CharacterData` nodes may be empty.
  Specified by:
    `getLength` in interface `org.w3c.dom.CharacterData`

### substringData

    public java.lang.String substringData(int offset,
                                          int count)
                                   throws org.w3c.dom.DOMException

  Extracts a range of data from the node.
  Specified by:
    `substringData` in interface `org.w3c.dom.CharacterData`
  Parameters:
    `offset` - Start offset of substring to extract.
    `count` - The number of 16-bit units to extract.
  Returns:
    The specified substring. If the sum of `offset` and `count` exceeds the `length`, then all 16-bit units to the end of the data are returned.
  Throws:
    `org.w3c.dom.DOMException` - INDEX_SIZE_ERR: Raised if the specified `offset` is negative or greater than the number of 16-bit units in `data`, or if the specified `count` is negative.
    DOMSTRING_SIZE_ERR: Raised if the specified range of text does not fit into a `DOMString`.

### appendData

    public void appendData(java.lang.String arg)
                    throws org.w3c.dom.DOMException

  Append the string to the end of the character data of the node. Upon success, `data` provides access to the concatenation of `data` and the `DOMString` specified.
  Specified by:
    `appendData` in interface `org.w3c.dom.CharacterData`
  Parameters:
    `arg` - The `DOMString` to append.
  Throws:
    `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

### insertData

    public void insertData(int offset,
                           java.lang.String arg)
                    throws org.w3c.dom.DOMException

  Insert a string at the specified 16-bit unit offset.
  Specified by:
    `insertData` in interface `org.w3c.dom.CharacterData`
  Parameters:
    `offset` - The character offset at which to insert.
    `arg` - The `DOMString` to insert.
  Throws:
    `org.w3c.dom.DOMException` - INDEX_SIZE_ERR: Raised if the specified `offset` is negative or greater than the number of 16-bit units in `data`.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

### deleteData

    public void deleteData(int offset,
                           int count)
                    throws org.w3c.dom.DOMException

  Remove a range of 16-bit units from the node. Upon success, `data` and `length` reflect the change.
  Specified by:
    `deleteData` in interface `org.w3c.dom.CharacterData`
  Parameters:
    `offset` - The offset from which to start removing.
    `count` - The number of 16-bit units to delete. If the sum of `offset` and `count` exceeds `length` then all 16-bit units from `offset` to the end of the data are deleted.
  Throws:
    `org.w3c.dom.DOMException` - INDEX_SIZE_ERR: Raised if the specified `offset` is negative or greater than the number of 16-bit units in `data`, or if the specified `count` is negative.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

### replaceData

    public void replaceData(int offset,
                            int count,
                            java.lang.String arg)
                     throws org.w3c.dom.DOMException

  Replace the characters starting at the specified 16-bit unit offset with the specified string.
  Specified by:
    `replaceData` in interface `org.w3c.dom.CharacterData`
  Parameters:
    `offset` - The offset from which to start replacing.
    `count` - The number of 16-bit units to replace. If the sum of `offset` and `count` exceeds `length`, then all 16-bit units to the end of the data are replaced; (i.e., the effect is the same as a `remove` method call with the same range, followed by an `append` method invocation).
    `arg` - The `DOMString` with which the range must be replaced.
  Throws:
    `org.w3c.dom.DOMException` - INDEX_SIZE_ERR: Raised if the specified `offset` is negative or greater than the number of 16-bit units in `data`, or if the specified `count` is negative.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

### splitText

    public org.w3c.dom.Text splitText(int offset)
                               throws org.w3c.dom.DOMException

  Breaks this node into two nodes at the specified `offset`, keeping both in the tree as siblings. After being split, this node will contain all the content up to the `offset` point. A new node of the same type, which contains all the content at and after the `offset` point, is returned. If the original node had a parent node, the new node is inserted as the next sibling of the original node. When the `offset` is equal to the length of this node, the new node has no data.
  Specified by:
    `splitText` in interface `org.w3c.dom.Text`
  Parameters:
    `offset` - The 16-bit unit offset at which to split, starting from `0`.
  Returns:
    The new node, of the same type as this node.
  Throws:
    `org.w3c.dom.DOMException` - INDEX_SIZE_ERR: Raised if the specified offset is negative or greater than the number of 16-bit units in `data`.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

### isElementContentWhitespace

    public boolean isElementContentWhitespace()

  DOM Level 3 CR
  Specified by:
    `isElementContentWhitespace` in interface `org.w3c.dom.Text`

### getWholeText

    public java.lang.String getWholeText()

  Description copied from interface: `org.w3c.dom.Text`
  Returns all text of `Text` nodes logically-adjacent text nodes to this node, concatenated in document order.
  For instance, in the example below `wholeText` on the `Text` node that contains "bar" returns "barfoo", while on the `Text` node that contains "foo" it returns "barfoo".
  Specified by:
    `getWholeText` in interface `org.w3c.dom.Text`

### replaceWholeText

    public org.w3c.dom.Text replaceWholeText(java.lang.String content)
                                      throws org.w3c.dom.DOMException

  Description copied from interface: `org.w3c.dom.Text`
  Replaces the text of the current node and all logically-adjacent text nodes with the specified text. All logically-adjacent text nodes are removed including the current node unless it was the recipient of the replacement text.
  This method returns the node which received the replacement text. The returned node is:
  - `null`, when the replacement text is the empty string;
  - the current node, except when the current node is read-only;
  - a new `Text` node of the same type ( `Text` or `CDATASection`) as the current node inserted at the location of the replacement.
  For instance, in the above example calling `replaceWholeText` on the `Text` node that contains "bar" with "yo" in argument results in the following:
  Where the nodes to be removed are read-only descendants of an `EntityReference`, the `EntityReference` must be removed instead of the read-only nodes. If any `EntityReference` to be removed has descendants that are not `EntityReference`, `Text`, or `CDATASection` nodes, the `replaceWholeText` method must fail before performing any modification of the document, raising a `DOMException` with the code `NO_MODIFICATION_ALLOWED_ERR`.
  For instance, in the example below calling `replaceWholeText` on the `Text` node that contains "bar" fails, because the `EntityReference` node "ent" contains an `Element` node which cannot be removed.
  Specified by:
    `replaceWholeText` in interface `org.w3c.dom.Text`
  Following copied from interface: `org.w3c.dom.Text`
  Parameters:
    `content` - The content of the replacing `Text` node.
  Returns:
    The `Text` node created with the specified content.
  Throws:
    `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if one of the `Text` nodes being replaced is readonly.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2007 The Apache Software Foundation. All Rights Reserved.